/*
*/

#ifndef CAPTURE_H
#define CAPTURE_H

#include "common.h"


class Device;

/**
 * @class CapturePin
 *
 * The Audio capture pin class.
 */
class CapturePin
{
public:


public:
    static NTSTATUS DispatchCreate(KSPIN *ksPin, IRP *irp);
    static NTSTATUS DispatchSetState(KSPIN *ksPin, KSSTATE toKsState, KSSTATE fromKsState);
    static NTSTATUS DispatchSetFormat(KSPIN *ksPin,
                                      KSDATAFORMAT *oldKsFormat, KSMULTIPLE_ITEM *oldKsAttributeList,
                                      const KSDATARANGE *ksDtaRange, const KSATTRIBUTE_LIST *ksAttributeRange);
    static NTSTATUS DispatchProcess(KSPIN *ksPin);
    static NTSTATUS IntersectHandler(KSFILTER *ksFilter, IRP *irp, KSP_PIN *ksPinInstance,
                                     KSDATARANGE *ksCallerDataRange, KSDATARANGE *ksDescriptorDataRange,
                                     ULONG bufferSize, VOID *data, ULONG *dataSize);

private:
    CapturePin (KSPIN *ksPin);
    ~CapturePin();

    NTSTATUS SetState(KSSTATE toKsState, KSSTATE fromKsState);
    NTSTATUS Process();
    NTSTATUS CleanupReferences();

private:
    static void Cleanup(CapturePin *pin);

private:
    KSPIN *m_ksPin;   /*!< The AVStream pin we're associated with. */
    Device *m_device; /*!< Pointer to the internal device object for our capture device.
                           We access the "fake" hardware through this object. */
};

#endif // CAPTURE_H
