/*
*/

#ifndef DEVICE_H
#define DEVICE_H

#include "common.h"


class Device
{
public:
    static NTSTATUS DispatchPnpAdd(KSDEVICE *ksDeviceObject);
    static NTSTATUS DispatchPnpStart(KSDEVICE *ksDeviceObject, IRP *irp,
                                     CM_RESOURCE_LIST *translatedResourceList,
                                     CM_RESOURCE_LIST *untranslatedResourceList);
    static void DispatchPnpStop(KSDEVICE *ksDeviceObject, IRP *irp);

private:
    Device(KSDEVICE *ksDeviceObject);
    ~Device();

    NTSTATUS PnpAdd();
    NTSTATUS PnpStart();
    void PnpStop();

private:
    static void Cleanup(Device *device);

private:
    KSDEVICE *m_ksDeviceObject;
};

#endif // DEVICE_H

